
require 'fusion_tables_api/version'
require 'fusion_tables_api/authorization'
require 'fusion_tables_api/table'
require 'google/api_client'
require 'yaml'


class FusionTablesAPI
  GOOGLE_OAUTH_TOKEN_FILE = 'google_access_token.yml'
  attr_reader :client

  # @oauth_cred - Accepts hash with :client_id, :client_secret, or 
  # filename of file that contains the oauth credentials 'client_id', 'client_secret'
  # @google_api_client_options - Accepts options for the google_api_client, e.g. :application_name, :application_version
  # See here https://github.com/google/google-api-ruby-client/blob/master/lib/google/api_client.rb
  # @access_tokens - Accepts hash with :access_token, :refresh_token, or 
  # filename of file that contains the oauth tkens 'access_token', 'refresh_token'
  def initialize(oauth_cred, access_tokens = nil, google_api_client_options = {})
    @client = Google::APIClient.new(google_api_client_options)
    @fusion_tables_api = @client.discovered_api('fusiontables') # Should comment this out when testing

    load_authorization_credentials(oauth_cred)
    load_oauth_tokens(access_tokens) if access_tokens
    true
  end
end
