class FusionTablesAPI
  ##
  # Set Google API Client authorization credentials
  def set_access_token(access_token)
    @access_token = access_token # Needed to check if access token expires
    @client.authorization.access_token = @access_token
  end

  def set_refresh_token(refresh_token)
    @client.authorization.refresh_token = refresh_token
  end

  # TODO Why not rewrite the oauth tokens file that may be given?
  def store_new_access_token
      @authorization_tokens['access_token'] = @client.authorization.access_token 
      File.open(GOOGLE_OAUTH_TOKEN_FILE, 'w+') { |f| f.write(@authorization_tokens.to_yaml)}
      true
  end

  # Takes hash or file and loads oauth credentials
  def load_authorization_credentials(cred)
    if cred.is_a?(Hash)
      @client.authorization.client_id = cred[:client_id]
      @client.authorization.client_secret = cred[:client_secret]
    else
      credentials = YAML.load_file(cred)
      @client.authorization.client_id = credentials["client_id"]
      @client.authorization.client_secret = credentials["client_secret"]
    end
    @client.authorization.redirect_uri = "http://localhost/oauth2callback"
    @client.authorization.scope = "https://www.googleapis.com/auth/fusiontables" 
    true
  end

  def load_oauth_tokens(oauth_tokens)
    if oauth_tokens.is_a?(Hash)
      set_access_token(oauth_tokens[:access_token])
      set_refresh_token(oauth_tokens[:refresh_token])
    else
      @authorization_tokens = YAML.load_file(oauth_tokens)
      set_access_token(@authorization_tokens['access_token'])
      set_refresh_token(@authorization_tokens['refresh_token'])
    end
    true
  end

  # Authorization
  def initial_authorization
    puts "1) Copy and paste the url below into your browser:" 
    authorize_uri = @client.authorization.authorization_uri
    puts authorize_uri
    # Launchy.open authorize
    puts ""

    puts "2) Accept the authorization request from Google in your browser"
    puts "3) Copy and paste the code parameter from the url and enter below:"
    print ">> "
    code = gets.chomp.strip

    @client.authorization.code = code
    # TODO Need to test this one below
    @authorization_tokens ||= @client.authorization.fetch_access_token!

    File.open(GOOGLE_OAUTH_TOKEN_FILE, 'w+') { |f| f.write(@authorization_tokens.to_yaml)}
    puts "Google OAuth Tokens written to #{GOOGLE_OAUTH_TOKEN_FILE}"
    true
  end
end
