require 'csv'

# TODO Will need to change this
class String
  def is_i?
    !!(self =~/^[-+]?[0-9]+$/)
  end
end

class FusionTablesAPI
  # TODO Might eventually want to create a table class
  ### FusionTables API Table methods ###

  def get_table_list
    result = @client.execute(api_method: @fusion_tables_api.table.list)
    store_new_access_token if @authorization_tokens && 
      @client.authorization.access_token != @authorization_tokens['access_token']
    JSON.parse(result.body)
  end

  def create_table(filename)
    csv_file = CSV.read(filename, {headers: true})
    headers = { 'Content-Type' => 'application/json' }

    column_names = []
    csv_file.headers.each_with_index do |header|
      type = csv_file[0][header].is_i? ? "NUMBER" : "STRING"
      column_names << { "name" => header, "type" => type }
    end

    request_body = { "columns" => column_names, "isExportable" => false, "name" => File.basename(filename, ".csv") }
    result = @client.execute(api_method: @fusion_tables_api.table.insert, headers: headers, body: request_body.to_json)
    store_new_access_token if @authorization_tokens && 
      @client.authorization.access_token != @authorization_tokens['access_token']
    JSON.parse(result.body)
  end

  def import_rows(filename, table_id, start_line= 0)
    headers = Hash.new
    headers[:content_type] = 'application/octet-stream'
    params = { 
      tableId: table_id, 
      startLine: start_line, 
      isStrict: false 
    } 
    request_body = File.read(filename)
    import_row_url = "https://www.googleapis.com/upload/fusiontables/v1/tables/tableId/import"

    result = @client.execute(uri: import_row_url, http_method: :post, body: request_body, headers: headers, parameters: params )
    result.data
  end

  def generate_table(filename, start_line= 0)
    create_response = create_table(filename)
    import_response = import_rows(filename, create_response["tableId"], start_line)
    [create_response, import_response]
  end

  def add_rows_to_existing_table(filename)
  end
end
